
#ifndef UDPPROTOCOLONFIGURATOR_H_
#define UDPPROTOCOLONFIGURATOR_H_

#include <Base_Configurator.h>
#include <UDP_Protocol.h>

namespace inaf::oasbo::ConnectionProtocols{
class UDPProtocolConfigurator : public BaseConfigurator{

public:
	UDPProtocolConfigurator(int argc, char **argv);
	UDPProtocolConfigurator();

	void setIp(std::string val){this->params["ip"] = val;}
	void setPort(int val){this->params["port"] = std::to_string(val);}

	std::map<std::string,std::string> getParams(){return this->params;}
	std::string getIp(){return this->params["ip"];}
	int getPort(){return stoi(this->params["port"]);}

	BaseProtocol  * createProtocol();
	UDPProtocol  * createUDPProtocol();
	void createUDPProtocol(UDPProtocol  &);



	void printConfiguration(){
		std::string confStr = "UDP Protocol Configuration:\n" + this->toString();
		std::cout << confStr << std::endl;
	}

};
}
#endif
